unit ScrollBar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TScrollBar2 = class(TScrollBar)
  protected
    function CheckIniChange(var Msg: TMessage): Boolean;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;

procedure Register;

implementation

constructor TScrollBar2.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Application.HookMainWindow(CheckIniChange);
end;

destructor TScrollBar2.Destroy;
begin
  Application.UnHookMainWindow(CheckIniChange);
  inherited Destroy;
end;

function TScrollBar2.CheckIniChange(var Msg: TMessage): Boolean;
begin
  Result := False;
  if Msg.Msg = wm_WinIniChange then
    if Kind = sbHorizontal then
      Height := GetSystemMetrics(SM_CYHSCROLL)
    else
      Width := GetSystemMetrics(SM_CYHSCROLL)
end;

procedure Register;
begin
  RegisterComponents('BUG', [TScrollBar2]);
end;

end.
